/***************************************************************************
 *   Copyright (C) 2006 by M.Fedotov   *
 *   mo_fedotov@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stream.h>
#include <iostream>

#include "logger.h"

logger2::logger2() 
{
	logfile = false;
	blocked = false;
	fName   = QString(LOGFILE);
}

logger2::~logger2() {}

void logger2::error(QString s)
{
	this->out((char *)"ERROR", s ,1, 1);
}

void logger2::cfg(QString s)
{
	this->out((char *)"CFG", s, 0, 0);
}

void logger2::info(QString s)
{
	this->out((char *)"INFO", s, 0, 1);
}

void logger2::debug(QString s)
{
	if (dbg)
		this->out((char *)"DEBUG", s, 0, 1);
}

void logger2::block(bool set)
{
	blocked = set;
}

void logger2::out(char *head, QString& str, int force, int timestamp) 
{
	time_t logtime;
	char *timestr;
        FILE *fplog;

 	if(!logfile) {
		cout << head << ": " << str << endl;
		return;
    	}	
	
   	if (blocked == false || force) {
    		fplog = fopen(fName.ascii(), "a");
    		if (fplog!=NULL) {
                        if (timestamp) {
   	    		    time(&logtime);
  	    		    timestr = (char *) ctime(&logtime);
   	    		    timestr[strlen(timestr)-1]=0;
   	    		    fprintf(fplog, "[%s] - ",timestr);
			}
	    		if(head!=NULL) {
				fprintf(fplog, "%s - ",head);
			}
	    		fprintf(fplog, "%s\n",str.ascii());
	    		fclose(fplog);
    		} else {
	    		cout << "Can't open log file >" << logfile << "<" << endl;
		}
    	} 
}

void logger2::truncate()
{
	// Just  truncate file
	FILE *fplog = fopen(fName.ascii(), "w");
	fclose(fplog);
}

void logger2::setFile(bool log, bool debug)
{
	logfile = log;
	dbg   = debug;
	//cout << "INFO: log = " << fName << " debug = "<< debug << endl;
}



